/*
 * Copyright 2019 by Kappich Systemberatung Aachen
 * ALL RIGHTS RESERVED.
 */

package de.bsvrz.dav.daf.accessControl.internal;

import de.bsvrz.dav.daf.accessControl.UserInfo;

/**
 * Intern benutzte Erweiterung des UserInfo-Interfaces, das einige zusätzliche Methoden bietet, die aber nicht nach außen sichtbar sein sollen.
 *
 * @author Kappich Systemberatung
 * @version $Revision: 0000 $
 */
public interface UserInfoInternal extends UserInfo {

	/** Inkrementiert den Referenzzähler um eins. */
	void incrementReference();

	/** Dekrementiert den Referenzzähler um eins. */
	void decrementReference();

	/**
	 * Prüft, ob keine Referenzen mehr vorhanden sind, und das Objekt gelöscht werden darf.
	 *
	 * @return {@code true}, wenn der Benutzer vom System abgemeldet wurde.
	 */
	boolean canBeSafelyDeleted();

	/**
	 * Sollte aufgerufen werden, wenn das Objekt nicht mehr gebraucht wird. Meldet die Empfänger für die Daten atg.benutzerParameter und je nach Implementierung
	 * eventuell weitere ab.
	 */
	void stopDataListener();
}
